{ Autorennen Part III  by Ralf van den Heuvel 2006

  Wissenswertes:
    Die Welt besteht aus Quadranten (10 x 10 Quadranten)
    Jeder Quadrant ist 500 x 500 Einheiten gross
    Es gibt Objekte, die einem Quadranten zugeordnet sind.

    die Array-Hierachie ist folgende:
    Quadrant kapselt...
      statisches Element kapselt...
        Objekt kapselt...
          Vertices und diverse
          Polygone
            Kennungen, welche Vertices pro Polygon verbunden werden sollen
}

Program apimatrix;

uses
  Windows,
  Messages,
  SysUtils,
  Graphics,
  DatenVektor in 'DatenVektor.pas';

type TRect = record //Ein Blanko-Rechteck
  Left, Top, Right, Bottom: Integer;
end;

type
  TVertice=Record   //ein Punkt IM 3D Raum
    x,y,z:single;
end;

type
  TPolygon=Record     //Werte eines Blanko Polygon (Unterordnug des Objekts)
    typ:integer;      //Type 0=Rahmen Polygon fr Kollisionscheck 9=zu zeigende Grafik
    color: TColor;    //Farbe des Polygons
    Texture: integer; //Tapetenoffset
    collision:bool;   //Collisionsprfung bei Polygon?
    DrawCou:integer;  //Anzahl der zu verbindenden Vertices des zugehrigen Objekts
    Draw: PiArray ; //array of integer; //Offsets der Vertices
end;

type
  TObjekt=RECORD              //Ein Objekt in der Welt (Auto, Hinderniss, Hintergrund)
    text: array [0..20] of char;
    typ:byte;                 //Type des Objekts (wird nicht verwendet)
    VertCount: integer;       //Anzahl Vertices im Objekt
    vert: PsArray;  //  array of TVertice;   //diverse Vertices
    PolyCou:integer;          //Anzahl Polygone im Objekt
    poly: array of TPolygon;   //Polygonzeiger
end;

type
  TStatic=Record        //Statische Zuordnung eines Objekts zu einem Quadranten
    dx,dy,dz:single;    //Verschiebung Objekt im Quadranten
    umx,umy,umz:single; //Drehung des Objekts um eigene Achse
    ob:integer;         //zugewiesenes Objekt
end;

type
  TQuadrant=RECORD        //Eine Einheit in der Welt . Diese kapselt diverse statische Elemente, die auf Objekte zeigen. Diese Objekte werden schliesslich dargestellt.
    x,y,z:integer;        //Pos. des Quadranten in der Welt
    co:integer;           //Anzahl Objekte im Quadranten
    st:array of TStatic; //Zeiger auf diverse Objekte in dem Quadranten
end;

type
  TActor=Record
    x,y,z:single;	   //Position in der Welt (wo bin ich in der 10*500 x 10*500 Welt)
    qx,qy,qz:single; //Position im Quadranten (wo bin ich in der 500x500 Quadrantenmatrix)
    wx,wy,wz:integer; //Pos in Quadrantenmatrix (wo bin ich in der 10x10 Unterteilung der Welt in Quadranten)
    umx,umy,umz:single;    //Letzte Winkel (Winkel um X-Achse ...)
    lx,ly,lz:single;	   //Letzte Position (last x, last y ...)
    lumx,lumy,lumz:single; //Letzte Winkel (last Winkel um X ...)
    ob:integer;		   //Objekt Offset (Welches Objekt verwendet der Actor)
    sp:single;  	   //Speed des Actors
    kmh:single;      //Kilometer pro Stunde
    quadrant:integer; //In welchem Quadranten steckt der Actor gerade?
end;

Type
  TLines=Record
    Obj:integer;		   //auf Kollision zu prfende Linie gehrt zu welchem Objekt?
    Typ:integer;       //welcher Typ hat diese Linie
    x1,y1,x2,y2:single;	   //2D-Koordinaten der Linie, die auf Kollision geprft werden soll
end;

Type
  TKollisionsLinien=Record
    LineCou:integer;
    Lines: array of TLines;
end;

const
  AppName = 'AutorennenPartII';	   //Application-Name
  pi=3.1428;		    //Konstante fr Ausrechnung Bogenma des Winkels
  WXSize = 10;      //X Size der Welt, sprich Anzahl der Quadranten nebeneinander
  WYsize = 10;
  QXSize = 500;     //X Size des Quadranten
  QYSize = 500;     //Y Size des Quadranten
  VXRange = 1;      //Zeichne nur Quadranten die n Quadranten um den aktuellen
  VYRange = 1;      //Quadranten des gesteuerten Actors herum sind.
var
  //Allgemeine System Verwaltung
  AMessage:TMsg;		      	//Systemmessage Struktur/Record
  HWindow:HWND;				      //Handle auf das Window
  WindowClass:TWndClass; 		//neue Fensterklasse im System
  taste: array [0..255] of bool;	//Feld mit gedrckten Tastaturwerten
  lastkey: integer;			    //Welche Taste war die letze - dient nur der Anzeige
  running: bool = true; 		//Solange running=true -> Programm aktiv
  sysmes: bool; 			      //Ergebnis von GetMessage Funktion am Ende des Prgs.
  dc: HDC; 				          //Gertekontext Fenster
  canvas: TCanvas;			    //Standard Grafikplattform
  //Frames per Second Verwaltung
  SecCounter:integer;       //Sekundezhler fr automatischer Wechsel der Ansicht
  ifps:integer;				      //Momentan F/s
  lastfps:integer;			    //letzter F/S Wert - Grundlage fr Syncronisation
  itimold,itimnew,itimdel:integer;	//Hilfsvariablen F/S

  //Fenster und Bitmaps
  bg:TBitmap;				            //Bitmap, in der gezeichnet wird
  myRect:Windows.TRect;			    //fr Grsse der Bitmap in Pixel
  winheight,winwidth:integer;		//fr def. Grsse des Windows
  //Sonstiges
  qua: array of TQuadrant;	    //Matrix Array stellt die Quadranten der Welt dar
  obj: array of TObjekt;	      //Objekt Array enthlt die diversen Objekte in einem Quadranten
  act: array of TActor;		    //Actor (Objekt, da durch den Anwender gesteuert wird) Array
  slin: array of TKollisionsLinien; //Auf Kollision zu prfende Linien der statischen Objekte
  alin: array of TKollisionsLinien; //Auf Kollision zu prfende Linien der Actoren
  Actors:integer;             //Wieviele Acteure gibt es
  Welt:integer;		            //Die Welt besteht aus wieviel Quadranten in X-Richtung/horizontal
  xori,yori,zori:single;	    //Origin X,Y,Z - wo ist der Mittelpunkt des Bildschirms?
  ac,qc,oc,vc:integer; 		    //Offset Actor , Objekt-Offset
  x,y,z:single; 		          //Rotations-Procedure Incoming and Outgoing
  ux,uy,uz:single ; 		      //Rotationswerte in Rotationsprocedure
  alpha,beta,gamma:single; 	  //Bogenmass Winkel eines gesamten Objekts (nur Actor)
  Bogenmass:single;
  bShowCLines:boolean;        //Sollen die Kollisionslinien gezeigt werden
  Auge:single;                //symbolischer Abstand Auge zum Bildschirm

  camX,camY,camZ:single;            //x,y,z Camera Pos in der Welt
  camUmX,camUmY,camUmZ:single;      //Kamerawinkel um X,y,z Achse
  camDelX,camDelY,camDelZ:single;   //Kameraverschiebewerte um die Kameraposition
  camAlpha,camBeta,camGamma:single; //Bogenmae Kamerawinkel
  CamStartZ:single;                 //Start Z Wert der Kamera in einer Ansicht
  CamRotationWithCar:bool;          //Soll Kamera sich mit dem Fahrzeug drehen?
  CamMoveWithCar:boolean;           //Soll Kamera sich nit dem Fahrzeug bewegen?
  CamBehindCar:boolean;             //Soll die Kamera hinter dem Fahrzeug herfahren?
  CamAutoZoom:boolean;              //Soll abhngig von der Geschwiondigkeit des Fahrzeugs die Kamera Z Position angepasst werden?
  AutoChangeView:boolean;           //Soll alle paar Sekunden die Ansicht automtisch wechseln?

  Ansicht:integer;                  //Zugeordneter Wert einer Ansicht (0=Vogelpers.)
  AnsichtName:string;               //Name der aktuellen Ansicht
  AnsichtCounter:integer;           //Zhl-Hilfsvariable, wenn Kamera still steht

  //Variablen Kollisionsprfung
  stalincou,actlincou,StaLines,ActLines:integer; 	//Zhler gespeicherter Kollisions-Prf-Linien, MAx. Anzahl Kollisionslinien
  kreuzpunkt_ab:single;  	//Kreuzp. Streck A nach B
  kreuzpunkt_cd:single;  	//Kreuzp. Streck B nach C
  kreuzpunkt_x:single;   	//Koordinate Treffpunkt X
  kreuzpunkt_y:single;   	//Koordinate Treffpunkt Y

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//bentigte Proceduren und Funktionen...
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// diverse Perspektiven und Ansichten
//-----------------------------------------------------------------------------
Procedure PerspektiveVogel;
begin
  Ansicht:=0;
  AnsichtName:='Vogelperspektive';
  Auge:=300; //Abstand Auge Bildschirm KLEIN=weit weg GROSS=nah
  camDelZ:=55; camDelX:=0; camDelY:=0;
  camUmX:=0; camUmY:=0; camUmZ:=0;
  camX:=act[ac].x; camY:=act[ac].y; camZ:=act[ac].z;
  CamStartZ := CamDelZ;
  CamMoveWithCar:=true;
  CamRotationWithCar:=false;
  CamBehindCar:=false;
  CamAutoZoom:=true;
end;

Procedure PerspektiveRaum;
begin
  Ansicht:=1;
  AnsichtName:='Rumliche Vogelperspektive';
  Auge:=300; //Abstand Auge Bildschirm KLEIN=weit weg GROSS=nah
  camDelZ:=20; camDelX:=0; camDelY:=-30;
  camUmX:=-45; camUmY:=0; camUmZ:=0;
  camX:=act[ac].x; camY:=act[ac].y; camZ:=act[ac].z;
  CamStartZ := CamDelZ;
  CamMoveWithCar:=true;
  CamRotationWithCar:=false;
  CamBehindCar:=false;
  CamAutoZoom:=false;
end;

Procedure PerspektiveVogelInverse;
begin
  Ansicht:=2;
  AnsichtName:='Vogelperspektive Inverse';
  Auge:=300; //Abstand Auge Bildschirm KLEIN=weit weg GROSS=nah
  camDelZ:=55; camDelX:=0; camDelY:=0;
  camUmX:=0; camUmY:=0; camUmZ:=-1*act[ac].umz;
  camX:=act[ac].x; camY:=act[ac].y; camZ:=act[ac].z;
  CamStartZ := CamDelZ;
  CamMoveWithCar:=true;
  CamRotationWithCar:=true;
  CamBehindCar:=false;
  CamAutoZoom:=true;
end;

Procedure PerspektiveMotorhaube;
begin
  Ansicht:=3;
  AnsichtName:='Motorhaubenperspektive';
  Auge:=300; //Abstand Auge Bildschirm KLEIN=weit weg GROSS=nah
  camDelZ:=2; camDelX:=0; camDelY:=0.0095;
  camUmX:=-90; camUmY:=act[ac].umz; camUmZ:=0;
  camX:=act[ac].x; camY:=act[ac].y; camZ:=act[ac].z;
  CamStartZ := CamDelZ;
  CamMoveWithCar:=true;
  CamRotationWithCar:=true;
  CamBehindCar:=false;
  CamAutoZoom:=false;
end;

Procedure PerspektiveRaumHinterher;
begin
  Ansicht:=4;
  AnsichtName:='Rumlich hinterher';
  Auge:=300; //Abstand Auge Bildschirm KLEIN=weit weg GROSS=nah
  camDelZ:=10; camDelX:=0; camDelY:=14;
  camUmX:=-90; camUmY:=act[ac].umz; camUmZ:=0;
  camX:=act[ac].x; camY:=act[ac].y; camZ:=act[ac].z;
  CamStartZ := CamDelZ;
  CamMoveWithCar:=true;
  CamRotationWithCar:=true;
  CamBehindCar:=true;
  CamAutoZoom:=false;
end;

//-----------------------------------------------------------------------------
//Werte setzen
//-----------------------------------------------------------------------------
procedure setzevars;
var
  la,lq,ly,lx:integer; //Loop Actors
begin
  //Allgemein (Screen)
  winwidth:=600;        //Breite Fenster
  winheight:=600;       //Hhe Fenster
  myRect.left:=2;       //Grafik Bereich
  myRect.top:=26;
  myRect.right:=winwidth-2;
  myRect.bottom:=winheight-2;
  xori:=trunc(winwidth/2);	//Wo ist der X Mittelpunkt des Fensters
  yori:=trunc(winheight/2);	//Wo ist der y Mittelpunkt des Fensters
  //Timing
  ifps:=0;
  itimnew:=gettickcount;    //Zeit in Millisekunden seit dem Start des Computers
  itimold:=itimnew;
  //Kollisionslinien Feld lin
  bShowCLines:=false;       //zu prfende Kollisionslinien sollen nicht gezeichnet werden

  //Welt
  Welt:=WXSize*WYSize;      //Welt = 10 x 10 = 100 Quadranten
  SetLength(qua,Welt);      //100 Quadranten sollen erst mal in der Welt (Matrix) reichen
  SetLength(Obj,100);  		  //100 Objekte insgesamt tuns auch
  //
  Actors:=2;                //Es gibt zwei Actoren, zwischen denen mit F1 umgeschaltet werden kann

  //Rahmendaten der Actoren
    SetLength(act,actors);		//Array fr n Acteure dimensioniert
    ac:=0;			              //Offset des einzigen Actors
    act[ac].wx:=1;            //Pos X (0..9) in Weltmatrix 10x10
    act[ac].wy:=5;            //Pos Y (0..9) in Weltmatrix 10x10
    act[ac].qx:=250;          //Pos X im Quadranten (250=Mitte des Quad.)
    act[ac].qy:=250;
    act[ac].x:=act[ac].wx*QXSize+act[ac].qx;		//Position in der Welt <X>
    act[ac].y:=act[ac].wy*QYSize+act[ac].qy;		//Position in der Welt <Y>
    act[ac].quadrant:=act[ac].wy*10+act[ac].wx;  //Start im Quadranten 51
    act[ac].umz:=0;		        //Drehwinkel um Z Achse (Vogelperspektive, 2D Scenario)
    act[ac].ob:=1;  		      //Offset Objekt (gleich dreieckiges Objekt)
    act[ac].sp:=0.02;  		    //Beschleunigungs-Sumand

    SetLength(act,actors);		//Array fr n Acteure dimensioniert
    ac:=1;			//Offset des einzigen Actors
    act[ac].wx:=1;            //Pos X (0..9) in Weltmatrix 10x10
    act[ac].wy:=5;            //Pos Y (0..9) in Weltmatrix 10x10
    act[ac].qx:=260;          //Pos X im Quadranten
    act[ac].qy:=260;
    act[ac].x:=act[ac].wx*QXSize+act[ac].qx;		//Position in der Welt <X>
    act[ac].y:=act[ac].wy*QYSize+act[ac].qy;		//Position in der Welt <Y>
    act[ac].quadrant:=act[ac].wy*10+act[ac].wx;  //Start im Quadranten 51
    act[ac].umz:=10;		      //Drehwinkel um Z Achse (Vogelperspektive, 2D Scenario)
    act[ac].ob:=1;  		      //Offset Objekt (gleich dreieckiges Objekt)
    act[ac].sp:=0.02;		      //Anfangsspeed (km/h = sp * FramsPerSecond * 3,6 )

    ac:=0;            //Main Actor fr Steuerung ist der erste der beiden Actoren

  //Kollisionslinien der statischen Objekte initlialisieren
    SetLength(aLin,actors);
    for la:=0 to actors-1 do //Alle Actoren durchgehen
    begin
      SetLength(alin[la].Lines,100); //Platz fr 0...99 Kollisionslinien
    end;
    SetLength(sLin,Welt);
    for lq:=0 to Welt-1 do //alle Quadranten durchgehen
    begin
      SetLength(slin[lq].Lines,20); //Platz fr 0...99 Kollisionslinien
    end;

  //----------------------------------------------
  //HINDERNISS Objekt definieren (Quadrat)
  //----------------------------------------------
    oc:=0;
    Obj[0].text:='Quader'+#0;
    Obj[0].Typ:=1; 		    //Type 1=Hinderniss (wird nicht weiter abgefragt, da Kollisionsschalter auch im einzelnen Polygon)
    Obj[0].VertCount:=5;                     //4 Vertices hat dieses Objekt 0
    Obj[0].vert:=@Pyramide_Vertices;         //Zeiger .vert beinhaltet Startadresse des Arrays mit den Vertices des Krpers
    Obj[0].PolyCou:=2; 		//Anzahl Polygone im Objekt
    SetLength(Obj[0].Poly,Obj[0].PolyCou);
    //Polygon 0 im Objekt 0
    Obj[0].poly[0].typ:=0; //0=Rahmenpolygon zwecks Kollisionsprfung
    Obj[0].poly[0].color:=rgb(255,10,10);
    Obj[0].poly[0].Texture:=0;
    Obj[0].poly[0].collision:=true;
    Obj[0].poly[0].DrawCou:=5;
    Obj[0].poly[0].Draw := @Pyramide_Collision_Lines;  //Zeiger .draw beinhaltet Startadresse des Arrays mit den Linien-Offsets der Krper-Vertices dividiert durch 3
    //Polygon 1 im Objekt 0
    Obj[0].poly[1].typ:=9; //Grafikpolygon, dass nicht der Kollisionsprfung dient
    Obj[0].poly[1].color:=rgb(255,10,10);
    Obj[0].poly[1].Texture:=0;
    Obj[0].poly[1].collision:=false;
    Obj[0].poly[1].DrawCou:=11;
    Obj[0].poly[1].Draw := @Pyramide_Draw_Lines;       //Zeiger .draw beinhaltet Startadresse des Arrays mit den Linien-Offsets der Krper-Vertices dividiert durch 3

  //----------------------------------------------
  //Quadrantbegrenzung Objekt definieren (2 Linien / halbes Kreuz)
  //----------------------------------------------
    oc:=2;
    Obj[2].text:='Border'+#0;
    Obj[2].Typ:=2; 		    //ObjektType 2 = GFX, nicht auf Kollision prfen
    Obj[2].VertCount:=3;                     //3 Vertices hat dieses Objekt 2
    Obj[2].vert := @Grenze_Vertices;  //Zeiger .vert beinhaltet Startadresse des Arrays mit den Vertices des Krpers
    Obj[2].PolyCou:=1; 		//Anzahl Polygone im Objekt
    SetLength(Obj[2].Poly,Obj[2].PolyCou);	//Dimensionierung Feld der Polygone des Objekts 0
    //Polygon 0 im Objekt 2
    Obj[2].poly[0].typ:=9; //Grafikpolygon, dass nicht der Kollisionsprfung dient
    Obj[2].poly[0].color:=rgb(60,60,60);
    Obj[2].poly[0].Texture:=0;
    Obj[2].poly[0].collision:=false;
    Obj[2].poly[0].DrawCou:=3;
    Obj[2].poly[0].Draw := @Grenze_Draw_Lines;         //Zeiger .draw beinhaltet Startadresse des Arrays mit den Linien-Offsets der Krper-Vertices dividiert durch 3

  //----------------------------------------------
  //FAHRZEUG Objekt definieren (Dreieck)
  //----------------------------------------------
    oc:=1;
    Obj[1].text:='Triangle'+#0;
    Obj[1].Typ:=0; 		    //Type 0 = Actor
    Obj[1].VertCount:=12;                     //12 Vertices hat dieses Objekt 1
    Obj[1].Vert:=@Actor_Vertices;             //Zeiger .vert beinhaltet Startadresse des Arrays mit den Vertices des Krpers
    Obj[1].PolyCou:=2; 		//Anzahl Polygone im Objekt
    SetLength(Obj[1].Poly,Obj[1].PolyCou);	//Dimensionierung Feld der Polygone des Objekts 1
    //Polygon 0 im Objekt 1
    Obj[1].poly[0].typ:=0; //0=Rahmenpolygon zwecks Kollisionsprfung
    Obj[1].poly[0].color:=rgb(0,255,0);
    Obj[1].poly[0].Texture:=0;
    Obj[1].poly[0].collision:=true;
    Obj[1].poly[0].DrawCou:=7;
    Obj[1].poly[0].Draw:=@Actor_Collision_Lines;    //Zeiger .draw beinhaltet Startadresse des Arrays mit den Linien-Offsets der Krper-Vertices dividiert durch 3
    //Polygon 1 im Objekt 0
    Obj[1].poly[1].typ:=9; //Grafikpolygon, dass nicht der Kollisionsprfung dient
    Obj[1].poly[1].color:=rgb(0,180,0);
    Obj[1].poly[1].Texture:=0;
    Obj[1].poly[1].collision:=false;
    Obj[1].poly[1].DrawCou:=26;
    Obj[1].poly[1].Draw:=@Actor_Draw_Lines;       //Zeiger .draw beinhaltet Startadresse des Arrays mit den Linien-Offsets der Krper-Vertices dividiert durch 3

  //-------------------------------------------------------------
  //Quadrant definieren (Matrix mit einzelnen Objekten bestcken)
  //-------------------------------------------------------------
  for ly:=0 to WYSize-1 do     //alle Quadranten von links nach rechts
  begin
    for lx:=0 to WXSize-1 do   //und von oben nach unten durchgehen
    begin
      qc:=ly*WXSize+lx; //=Quadrant No zwischen 0...99
      qua[qc].x:=lx*QXSize;
      qua[qc].y:=ly*QYSize;
      qua[qc].co:=4; 			//Anzahl zugewiesener Objekte im Quadranten qc
      SetLength(qua[qc].st,qua[qc].co);

      qua[qc].st[0].dx:=150;		//Wo ist das Objekt im Quadranten? (Delaywerte x,y,z)
      qua[qc].st[0].dy:=350;
      qua[qc].st[0].dz:=0;
      qua[qc].st[0].ob:=0; 			//an der Stelle soll Objekt 0 gesetzt werden
      qua[qc].st[0].umz:=0;      //gedreht?

      qua[qc].st[1].dx:=220;  	//noch ein Objekt weiter rechts im Quadranten 0
      qua[qc].st[1].dy:=230; 		//weiter unten
      qua[qc].st[1].dz:=0;
      qua[qc].st[1].ob:=0; 			//an dieser Stelle soll auch Objekt 0 gesetzt werden
      qua[qc].st[1].umz:=60;    //gedreht?

      qua[qc].st[2].dx:=310;		//noch ein Objekt 0 in dem Quadranten 0 setzen...
      qua[qc].st[2].dy:=370;
      qua[qc].st[2].dz:=0;
      qua[qc].st[2].ob:=0;
      qua[qc].st[2].umz:=75;    //gedreht?

      qua[qc].st[3].dx:=0;			//noch ein Objekt 0 in dem Quadranten 0 setzen...
      qua[qc].st[3].dy:=0;
      qua[qc].st[3].dz:=0;
      qua[qc].st[3].ob:=2;      //Objekt 2 = Quadrantengrenzlinien
      qua[qc].st[3].umz:=0;     //gedreht?
    end;
  end;
  //Anfangsansicht und Modus
  PerspektiveVogel;
  AutoChangeView:=true;         //alle paar Sek. Ansicht wechseln
end;

//-----------------------------------------------------------------------------
//Bewegungswerte der Frames per Second Frequenz anpassen - je mehr Frams, desto kleiner der Bewegungswert
//-----------------------------------------------------------------------------
function sync(wert:single):single;
begin
  if lastfps=0 then exit;	//Keine Division durch Null zulassen
  result:=wert/lastfps;		//Ergebnis gleich Bewegungswert durch Anzahl Bilder pro Sekunde
end;

//-----------------------------------------------------------------------------
//Ansicht laut Wert einschalten
//-----------------------------------------------------------------------------
procedure SetzeAnsicht;
begin
  if Ansicht=0 then PerspektiveVogel;
  if Ansicht=1 then PerspektiveRaum;
  if Ansicht=2 then PerspektiveVogelInverse;
  if Ansicht=3 then PerspektiveMotorhaube;
  if Ansicht=4 then PerspektiveRaumHinterher;
end;

//-----------------------------------------------------------------------------
// autom. Wechsel der Ansicht
//-----------------------------------------------------------------------------
procedure AnsichtAutomatischWechseln;
begin
  if AutoChangeView then //nur wenn Modus aktiv ist, Kann durch F4 umgeschaltet werden
    if SecCounter=5 then //alle 5 Sekunden Ansicht wechseln
    begin
      SecCounter:=0;     //und Sek. Zhler resetten
      inc(Ansicht);      //nchste Ansicht
      if Ansicht=5 then Ansicht:=0; //es gibt nur 5 Ansichten
      SetzeAnsicht; //Nun spezifische Werte der Ansicht setzen
    end;
    if SecCounter=2 then CamMoveWithCar:=false; //und eventuell Kamera nach ein paar weiteren Sekunden still stehen lassen
end;

//-----------------------------------------------------------------------------
// Tastatur abfragen - Pfeiltasten werden woanders abgefragt
//-----------------------------------------------------------------------------
procedure tastatur;
begin
  if taste[vk_escape] then running:=false;		//Programmende durch ESC Taste
  //Actor wechseln mit F1
  if taste[vk_f1] then
  begin
    inc(ac);
    if ac=actors then ac:=0;
    taste[vk_f1]:=false;
  end;
  //Ansicht wechseln mit F2
  if taste[vk_f2] then
  begin
    inc(Ansicht);
    if Ansicht=5 then Ansicht:=0;
    SetzeAnsicht;
    taste[vk_f2]:=false;
  end;
  //Camera nimmt Position des Actors an oder nicht mit F3
  if taste[vk_f3] then
  begin
    CamMoveWithCar:=not(CamMoveWithCar);
    if CamMoveWithCar then SetzeAnsicht;
    taste[vk_f3]:=false;
  end;
  //Auto Ansicht - Wechselt alle paar Sekunden automatisch oder nicht mit F4
  if taste[vk_f4] then
  begin
    AutoChangeView:=not(AutoChangeView);
    taste[vk_f4]:=false;
    SecCounter:=0;
  end;
  //symbolischer Augenabstand beeinflussen, wenn not AutoChangeView
  if taste[97] then auge:=auge+sync(30); // Ziffer 1
  if (taste[103]) and (auge>0) then auge:=auge-sync(30); // Ziffer 7
  //Camera bewegen (Zifferblock)
  if taste[100] then camDelX:=camDelX-sync(20); // 4
  if taste[102] then camDelX:=camDelX+sync(20); // 6
  if taste[104] then camDelY:=camDelY-sync(20); // 8
  if taste[98] then camDelY:=camDelY+sync(20);  // 2
  if taste[109] then camDelZ:=camDelZ-sync(20); // -
  if taste[107] then camDelZ:=camDelZ+sync(20); // +
  //Camera drehen
  if taste[vk_f5] then camUmX:=camUmX-sync(10);
  if taste[54] then camUmX:=camUmX+sync(10);
  if taste[vk_f6] then camUmY:=camUmY+sync(20);
  if taste[55] then camUmY:=camUmY-sync(20);
  if taste[vk_f7] then camUmZ:=camUmZ+sync(10);
  if taste[56] then camUmZ:=camUmZ-sync(10);
end;

//-----------------------------------------------------------------------------
//Frames per Second besorgen
//-----------------------------------------------------------------------------

procedure zeitmessung;
begin
  inc(ifps);
  itimnew:=gettickcount;	//Millisekunden Zhler seit Systemstart
  itimdel:=itimnew-itimold;
  if itimdel>1000 then		//nach Sekunde Zhlergebnis merken...
  begin
    inc(SecCounter);
    itimold:=itimnew;
    lastfps:=ifps;		//...in lastfps steht der Wert den man braucht
    ifps:=0;
  end;
end;

//-----------------------------------------------------------------------------
//Etwas auf dem Schirm anzeigen
//-----------------------------------------------------------------------------

procedure screentext;
begin
  bg.canvas.textout(20,32,'Sek.='+inttostr(SecCounter)+'   Taste='+inttostr(lastkey)+'   F/S='+inttostr(lastfps)+'    Ansicht[ F2 ]='+AnsichtName+'   Kamerastillstand[ F3 ]   AutoViewChange[ F4 ]');
  bg.Canvas.TextOut(20,46,'ActorNo[ F1 ]= '+inttostr(ac)+'   Actor X,Y in Welt='+inttostr(trunc(Act[ac].x))+','+inttostr(trunc(Act[ac].y))+'   Speed='+inttostr(trunc(act[ac].kmh))+' km/h');
  bg.Canvas.TextOut(20,60,'Actor X,Y im Quadranten '+inttostr(Act[ac].quadrant)+'= '+inttostr(trunc(Act[ac].qx))+','+inttostr(trunc(Act[ac].qy)));
  bg.Canvas.TextOut(20,76,'ACTOR DREHUNG UM X,Y,Z = '+inttostr(trunc(Act[ac].UmX))+','+inttostr(trunc(Act[ac].UmY))+','+inttostr(trunc(Act[ac].UmZ)));

  bg.Canvas.TextOut(20,winheight-60,'CAMERA DREHUNG  [F5,F6,F7]    = '+inttostr(trunc(camUmX))+','+inttostr(trunc(camUmY))+','+inttostr(trunc(camUmZ)));
  bg.Canvas.TextOut(20,winheight-46,'CAMERA POS X,Y,Z  = '+inttostr(trunc(camX))+','+inttostr(trunc(camY))+','+inttostr(trunc(camZ)));
  bg.Canvas.TextOut(20,winheight-32,'CAMERA DELAY X[4,8]  Y[8,2]  Z[+,-] = '+format('%4.4f',[camDelX])+' , '+format('%4.4f',[camDelY])+' , '+format('%4.4f',[camDelZ])+'     AUGENABSTAND[1,7]='+inttostr(trunc(Auge)));
end;

//-----------------------------------------------------------------------------
//3d Werte in 2d umrechnen
//-----------------------------------------------------------------------------
procedure Projektion;
begin
  if z=0 then z:=0.00001;
  //Datenumrechnung fr die 2D Darstellung
  x:=trunc( x * Auge / z + xori ); //dx=Delaywert Auge=Manipulationsfaktor q=neuer 2D Wert X Achse
  y:=trunc( y * Auge / z + yori );
end;

//-----------------------------------------------------------------------------
//Rotieren um Achsen
//bergeben werden
//	x,y,z (Punkt wird um 0,0,0 rotiert)
//	umx,umy,umz (Um welche Achse rotieren - Angabe in Grad)
// Ergebnis sind die neuen Koordinaten
//	x,y,z
//-----------------------------------------------------------------------------
procedure Rotation(alpha,beta,gamma:single);
var
  x1,y1,z1:single;
begin
  if (alpha+beta+gamma)<>0 then
  begin
    // Rotation um die x-Achse
    x1:=x;
    y1:=(y*cos(alpha)-z*sin(alpha));
    z1:=(y*sin(alpha)+z*cos(alpha));
    // Rotation um die Y-Achse
    x:=(x1*cos(beta)-z1*sin(beta));
    y:=y1;
    z:=(x1*sin(beta)+z1*cos(beta));
    // Rotation um die Z-Achse
    z1:=z;
    x1:=(x*cos(gamma)-y*sin(gamma));
    y1:=(x*sin(gamma)+y*cos(gamma));
    // Werte speichern
    x:=x1;
    y:=y1;
    z:=z1;
  end;
end;

//-----------------------------------------------------------------------------
//Kollisionslinienkoordinaten ermitteln und merken
//-----------------------------------------------------------------------------
procedure calcStaticLines;
var
  la,lm,lp,ld:integer;		//for "L"oop- ... Variablen
  quadrant:integer; 			//Matrix/Quadrantenoffset
  oof:integer;			      //Offset eines Objekts
  odx,ody,odz:single;		  //Delaywert eines Objekts (wo ist es in der Welt?)
  dtype:integer;          //Drawtype Polygon Rahmen, Grafik ...
  vertice:integer;        //Offset Vertice
  qmerk:string;
  Rotierung:bool;
  LastX,LastY:single;
  LinCou:integer;
begin
  //Zeichnen
  for la:=0 to Actors-1 do
  begin
    quadrant:=Act[la].quadrant;
    if pos(inttostr(quadrant),qmerk)=0 then //keinen Quadranten doppelt bearbeiten
    begin
      LinCou:=0; //Kollisionslinienzhler fr diesen Actor resetten
      qmerk:=qmerk+','+inttostr(quadrant); //Quadrant als schon bearbeitet merken
      if qua[quadrant].co>0 then		//nur behandeln, wenn auch Objekte da sind
      begin
        //Objekt im Quadrant
        for lm:=0 to qua[quadrant].co-1 do 		//Alle Objekte verarbeiten
        begin
          odx:=qua[quadrant].x+qua[quadrant].st[lm].dx+xori-act[ac].x; 	//Delay X des Objekts in der Welt (Verschiebung = X-Pos Objekt + Mitte Window + Position des Actors)
          ody:=qua[quadrant].y+qua[quadrant].st[lm].dy+yori-act[ac].y; 	//Delay Y
          odz:=qua[quadrant].z+qua[quadrant].st[lm].dz+zori-act[ac].z;	//Delay Z
          oof:=qua[quadrant].st[lm].ob; 		  	//Offset Objekt
          //Vorbereitung rotation betrifft gesamtes Objekt
          ux:=qua[quadrant].st[lm].umx; //Rotation um X
          uy:=qua[quadrant].st[lm].umy; //Rotation um Y
          uz:=qua[quadrant].st[lm].umz; //Rotation um Z
          if ux+uy+uz>0 then
          begin
            rotierung:=true;
            alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
          end
          else
            rotierung:=false;
          //Polygone des Objekts
          for lp:=0 to Obj[oof].PolyCou-1 do
          begin
            if Obj[oof].Poly[lp].typ=0 then //nur Rahmenobjekt zulassen
            begin
              for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do
              begin
                  vertice:=Obj[oof].Poly[lp].draw^[ld]*3; //Offset Vertice des Objekts
                  x:=Obj[oof].vert^[vertice+0];
                  y:=Obj[oof].vert^[vertice+1];
                  z:=Obj[oof].vert^[vertice+2];
                  if rotierung then rotation(alpha,beta,gamma);
                  if bShowCLines then
                  begin
                    bg.Canvas.Pen.Color:=Obj[oof].Poly[lp].color;
                    if ld=0 then bg.Canvas.moveto(trunc(odx+x),trunc(ody+y)) else
                      bg.Canvas.lineto(trunc(odx+x),trunc(ody+y));
                  end;
                  if ld>0 then //wenn es nicht der Startpunktz der Linie ist
                  begin
                    inc(LinCou);
                    sLin[quadrant].Lines[LinCou].Obj:=lm; //MatrixObjekt merken
                    sLin[quadrant].Lines[LinCou].Typ:=Obj[oof].typ; //Typ merken 
                    sLin[quadrant].Lines[LinCou].x1:=LastX;
                    sLin[quadrant].Lines[LinCou].y1:=LastY;
                    sLin[quadrant].Lines[LinCou].x2:=odx+x;
                    sLin[quadrant].Lines[LinCou].y2:=ody+y;
                  end;
                  LastX:=odx+x;
                  LastY:=ody+y;
              end;
            end;
          end;
        end;
      end;
      sLin[quadrant].LineCou:=LinCou; //Anzahl gemerkter Linien fr Kollisionscheck in diesem Quadranten festhalten
    end;
  end;
end;

//-----------------------------------------------------------------------------
//findet Kollision zwischen zwei Linien statt?
//bergabe
//	ax,ay,bx,by - Linie 1
//	cx,cy,dx,dy - Linie 2
//Ergebnis
//	Bool Result -> bei Kollision = true
//	kreuzpunkt_x und kreuzpunkt_y -> wo fand das crossing statt
//-----------------------------------------------------------------------------
function collision(ax,ay,bx,by,cx,cy,dx,dy:single):bool;
var
  rn,rd,sn:single;       //Hilfsvariablen der Funktion
begin
  rd:=(bx-ax)*(dy-cy)-(by-ay)*(dx-cx);
  If rd=0
    then result:=False
  else
    begin
      rn:=(ay-cy)*(dx-cx)-(ax-cx)*(dy-cy);
      sn:=(ay-cy)*(bx-ax)-(ax-cx)*(by-ay);
      kreuzpunkt_ab:=rn/rd;
      kreuzpunkt_cd:=sn/rd;
      kreuzpunkt_x:=ax+kreuzpunkt_ab*(bx-ax);
      kreuzpunkt_y:=ay+kreuzpunkt_ab*(by-ay);
      if (kreuzpunkt_ab<0) Or (kreuzpunkt_ab>1) Or (kreuzpunkt_cd<0) Or (kreuzpunkt_cd>1)
        Then  result:=false
      else result:=true;
    end;
end;

//-----------------------------------------------------------------------------
//Kollisionslinien/Umrandung des Actors berechnen
//-----------------------------------------------------------------------------
procedure calcActorLines;
var
  la,lm,lp,ld:integer;		//for "L"oop- ... Variablen
  oof:integer;			//Offset eines Objekts
  odx,ody,odz:single;		//Delaywert eines Objekts (wo ist es in der Welt?)
  vertice:integer; //Offset Vertice
  xv0,yv0,zv0:single; //Wert des Vertices
  LastX,LastY:single;
  LinCou:integer;
begin
  //Zeichnen
  for la:=0 to Actors-1 do
  begin
    LinCou:=0;
    oof:=Act[la].ob;
    ux:=act[la].umx; //Rotation um X
    uy:=act[la].umy; //Rotation um Y
    uz:=act[la].umz; //Rotation um Z
    alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
    //Polygone des Objekts
    for lp:=0 to Obj[oof].PolyCou-1 do
    begin
      if Obj[oof].Poly[lp].typ=0 then //Rahmenobjekt?
      begin
        for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do
        begin
          with bg.Canvas do				//auf bg.canvas beziehen...
          begin
            vertice:=Obj[oof].Poly[lp].draw^[ld]*3; //*3;//Offset Vertice des Objekts
            x:=Obj[oof].vert^[vertice+0];  //x
            y:=Obj[oof].vert^[vertice+1];  //y
            z:=Obj[oof].vert^[vertice+2];  //z
            Rotation(alpha,beta,gamma);
            if la=ac then //Actor in Bildschirmmitte zeichnen
              begin
                odx:=x+xori;
                ody:=y+yori;
                odz:=z+zori;
              end
            else  //sonst dahin wo er hin gehrt
              begin
                odx:=x+xori+act[la].x-act[AC].x;
                ody:=y+yori+act[la].y-act[AC].y;
                odz:=z+zori-act[la].z-act[AC].z;
              end;
            if bShowCLines then
            begin
              bg.Canvas.Pen.Color:=Obj[oof].Poly[lp].color;
              if ld=0 then moveto(trunc(odx),trunc(ody)) else
                lineto(trunc(odx),trunc(ody));
            end;
            if ld>0 then
            begin
              inc(LinCou);
              aLin[la].Lines[LinCou].Obj:=la;
              aLin[la].Lines[LinCou].x1:=LastX;
              aLin[la].Lines[LinCou].y1:=LastY;
              aLin[la].Lines[LinCou].x2:=odx;
              aLin[la].Lines[LinCou].y2:=ody;
            end;
            LastX:=odx;
            LastY:=ody;
          end;
        end;
      end;
    end;
    aLin[la].LineCou:=LinCou;
  end;
end;

//-----------------------------------------------------------------------------
//3d Grafik zeichnen - es werden keine Kollisionslinien gezeichnet
//-----------------------------------------------------------------------------
procedure draw3dGFX;
var
  lx,ly,ls,lp,ld,la:integer;
  oof:integer;			//Offset eines Objekts
  vertice:integer;  //Offset Vertice
  LinCou:integer;
  Quadrant:integer;
  Objekt:integer;
  LastZ:single;
begin
  camAlpha:=camUmX*pi/180; camBeta:=camUmY*pi/180; camGamma:=camUmZ*pi/180; //Einmalige Berechnung fr Welt (Bogenmae der Winkel)
  for ly:=act[ac].wy-VYRange to act[ac].wy+VYRange do //Quadranten von links nach rechts durchgehen (um den Actor)
  begin
    for lx:=act[ac].wx-VXRange to act[ac].wx+VXRange do //Quadranten von oben nach unten durchgehen
    begin
      if (ly>=0) and (ly<WYSize) and (lx>=0) and (lx<WXSize) then //Quadranten selektieren (x 0..9 und y 0..9)
      begin
        Quadrant:=ly*WXsize+lx;             //aktueller Quadrant anhand ly und lx errechnen
        for ls:=0 to qua[Quadrant].co-1 do //Statisches Element im Quadranten durchgehen
        begin
          ux:=qua[Quadrant].st[ls].umx; //Rotation um X
          uy:=qua[Quadrant].st[ls].umy; //Rotation um Y
          uz:=qua[Quadrant].st[ls].umz; //Rotation um Z
          alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
          oof:=qua[Quadrant].st[ls].ob; //Objekt Offset
          //Polygone des Objekts
          for lp:=0 to Obj[oof].PolyCou-1 do
          begin
            if Obj[oof].Poly[lp].typ=9 then //Grafik-Polygon? Dann weiter...
            begin
              for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do
              begin
                with bg.Canvas do				//auf bg.canvas beziehen...
                begin
                  vertice:=Obj[oof].Poly[lp].draw^[ld]*3; //*3; //Offset Vertice des Objekts
                  x:=Obj[oof].vert^[vertice+0];  //x
                  y:=Obj[oof].vert^[vertice+1];  //y
                  z:=Obj[oof].vert^[vertice+2];  //z
                  Rotation(alpha,beta,gamma);   //Vertices des Objektes erstmal um die eigene Achse rotieren
                  // { Verschiebung des stat. Objektes }        - { Mittelpunkt der Welt }    =     Radius Objekt um Mittelpunkt Welt
                  x:=qua[Quadrant].x+qua[Quadrant].st[ls].dx+ x - camX;  //dann wird die neue X,Y,Z Position an die richtige Stelle gerckt
                  y:=qua[Quadrant].y+qua[Quadrant].st[ls].dy+ y - camY;
                  z:=qua[Quadrant].z+qua[Quadrant].st[ls].dz+ z - camZ;
                  Rotation(camAlpha,camBeta,camGamma);  // Die ganzen Koordinaten der Ansicht (Camera) entsprechen drehen
                  Projektion; //die 3d Werte nun in die 2d Werte x,y umrechnen

                  if z<0 then //nur Linien zeichnen, deren Z-Werte negativ sind.
                  begin
                    Pen.Color:=Obj[oof].Poly[lp].color;
                    if ld=0 then moveto(trunc(x),trunc(y)); //ld=0 -> Startpunkt des Polygons
                    if ld>0 then
                    begin
                      if LastZ<0 then lineto(trunc(x),trunc(y)); //ansonsten Linie zeichnen, wenn der letzte z Wert des Polygons auch negativ (im Sichtbereich) war
                      if LastZ>0 then moveto(trunc(x),trunc(y));
                    end;
                  end;
                  LastZ:=z;

                end;
              end;
            end;
          end;
        end;
        //Jetzt alle Actoren, die in dem Quadranten sind zeichnen
        for la:=0 to actors-1 do //alle Actoren
        begin
          if act[la].quadrant=Quadrant then //ist er auch im richtigen Quadranten , sonst erst gar nicht zeichnen, sieht man eh nicht
          begin
            oof:=Act[la].ob; //Objektnummer des Actors

            if (la=ac) and (CamRotationWithCar) then //ist Actor Hauptactor und rotiert die Camera mit dem Fahrzeug
            begin
              if Ansicht<3 then begin ux:=0; uy:=0; uz:=0; end; //keine Rotation in Vogelperspektiven weil Kamera sich nicht dreht
              if Ansicht>2 then begin ux:=0; uy:=0; uz:=act[la].umz; end; //Korrekturrotation in rmlicher Pers., weil sich die Kamera dreht
            end
            else      //wenn es halt nicht der Hauptactor ist, Drehwinkel besorgen fr alle Achsen
            begin
              ux:=act[la].umx; //Rotation um X
              uy:=act[la].umy; //Rotation um Y
              uz:=act[la].umz; //Rotation um Z
            end;

            alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
            //Polygone des Objekts
            for lp:=0 to Obj[oof].PolyCou-1 do //Alle Polygone des Objektes durchgehen
            begin
              if Obj[oof].Poly[lp].typ=9 then //Grafik des Objekts? dann weiter
              begin
                for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do //alle zu zeichnenden linien durchgehen
                begin
                  with bg.Canvas do				//auf bg.canvas beziehen...
                  begin
                    vertice:=Obj[oof].Poly[lp].draw^[ld]*3; //Offset Vertice des Objekts
                    x:=Obj[oof].vert^[vertice+0];  //x
                    y:=Obj[oof].vert^[vertice+1];  //y
                    z:=Obj[oof].vert^[vertice+2];  //z
                    Rotation(alpha,beta,gamma);   //Objekt um eigene Achse drehen
                    x:= act[la].x + x - camX;     //dann gedrehtes Objekt in der Welt verschieben
                    y:= act[la].y + y - camY;
                    z:= act[la].z + z - camZ;

                    if not CamRotationWithCar then Rotation(camAlpha,camBeta,camGamma); //Vogelperspektive

                    if (CamRotationWithCar) then //Rotiert die Kamera mit dem Fahrzeug? (Ansicht hinterher oder Motorhaube)
                      if la=ac then Rotation(camAlpha,camBeta,0) else  //Actor = Hauptactor, dann nicht um Z -Achse drehen
                        Rotation(camAlpha,camBeta,camGamma); //ansonsten schon um alle Achsen

                    Projektion; // 3d Werte wieder in 2d umrechnen

                    if z<0 then //nur Linien zeichnen, deren Z-Werte negativ sind.
                    begin
                      Pen.Color:=Obj[oof].Poly[lp].color;
                      if ld=0 then moveto(trunc(x),trunc(y));
                      if ld>0 then
                      begin
                        if LastZ<0 then lineto(trunc(x),trunc(y));
                        if LastZ>0 then moveto(trunc(x),trunc(y));
                      end;
                    end;
                    LastZ:=z;  //Z Wert merken fr nchste Linie

                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//Kamera je nach Modus und Ansicht bewegen
//-----------------------------------------------------------------------------
procedure BewegungCamera;
var
  DifX,DifY,DifZ,DifTemp:single;
begin

  if (not CamMoveWithCar) then
  begin
    //Differenz zwischen Kamera und Fahrzeug
    DifX:=CamX-act[ac].x;
    DifY:=CamY-act[ac].y;
    DifZ:=CamZ-act[ac].z;
    if Difx=0 then DifX:=0.00001;
    if Dify=0 then Dify:=0.00001;
    if Difz=0 then Difz:=0.00001;
    //PerspektiveVogel
    if Ansicht=0 then
    begin
      CamUmX:= ArcTan(DifY/DifZ)*180/PI;
      CamX:=act[ac].x;
    end;
    //Perspektive Raum
    if Ansicht=1 then
    begin
      CamUmX:= ArcTan(DifY/DifZ)*180/PI;
      CamX:=act[ac].x;
    end;
    //Perspektive Vogel Inverse
    if Ansicht=2 then
      CamMoveWithCar:=true;
    //PerspektiveMotorhaube und PerspektiveHinterher
    if Ansicht>2 then
    begin
      IF DifY>0 then
      begin
        CamX:=Act[ac].x ;
        CamY:=Act[ac].y - 40 ;
        inc(AnsichtCounter);
        if AnsichtCounter=2 then
        begin
          AnsichtCounter:=0;
          CamMoveWithCar:=true;
        end;
      end;
      if DifY<1 then
      begin
        CamUmY:= -1 * ArcTan(DifX/DifY)*180/PI;  //Winkel Camera fr PerspektiveMotorhaube und PerspektiveHinterher
        if CamUmY<0 then CamUmY:=CamUmY+360;
        if CamUmY>359 then CamUmY:=CamUmY-360;
      end;
    end;
  end;

  if CamMoveWithCar then
  begin
    if CamAutoZoom then
    begin
      if act[ac].sp>0 then CamDelZ:=CamStartZ+(act[ac].kmh/7)
        else CamDelZ:=CamStartZ;
    end;
    if CamRotationWithCar then //Camera soll in Abhngigkeit vom Fahrzeug mit rotieren - Actor bleibt stehen, Rest dreht sich um den Actor
    begin
      if Ansicht=2 then camUmZ:=-1*act[ac].umz; //Vogel Inverse
      if Ansicht=3 then camUmY:=act[ac].umz; //Motorhaube
    end;
    if not CamBehindCar then //Camera soll sich mit dem Actor bewegen - Actor ist Mittelpunkt
    begin
      camX := act[ac].x + camDelX;
      camY := act[ac].y + camDelY;
      camZ := act[ac].z + camDelZ;
    end;
    if Ansicht>2 then //Motorhaube und Hinterher
    begin
      camUmY:= act[ac].umz ;
      gamma:= ( act[ac].umz + 180 )   * PI / 180 ; beta:=0 ; alpha:=0 ;
      x:=0; y:=CamDelY ; z:=0;
      Rotation(alpha,beta,gamma);
      CamX:=x+act[ac].x;
      CamY:=y+act[ac].y;
      CamZ:=act[ac].z+camDelZ;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//Pfeiltasten abfragen, Actor bewegen, Bewegung begrenzen
//-----------------------------------------------------------------------------
procedure BewegungActor;
var
  la:integer;
begin
  for la:=0 to actors-1 do
  begin
    //Aktuelle Werte speichern fr Rcksetzung nach einer eventuellen Kollision
    act[la].lx:=act[la].x;
    act[la].ly:=act[la].y;
    act[la].lz:=act[la].z;
    //Alte Werte merken		//Beovr der Actor eine neue Drehposition einnimmt, bitte die aktuelle Position merken
    act[la].lumx:=act[la].umx;
    act[la].lumy:=act[la].umy;
    act[la].lumz:=act[la].umz;
    //Auf Tasten reagieren in Bezug auf Actor-Steuerung
    if la=ac then //nur bei gesteuertem Actor drauf eingehen
    begin
      if taste[39] then act[ac].umz:=act[ac].umz+sync(90);	//Pfeil rechts (Actor dreht sich um die Z-Achse nach rechts)
      if taste[37] then act[ac].umz:=act[ac].umz-sync(90);	//Pfeil links
      if taste[38] then act[ac].sp:=act[ac].sp+sync(0.1);	//Pfeil hoch	(Vorwrts beschleunigen)
      if taste[40] then act[ac].sp:=act[ac].sp-sync(0.2);	//Pfeil runter	(rckwrts beschleunigen)
    end;
    //Rotation im Rahmen halten 0...359 Grad
    if act[la].umz>360 then act[la].umz:=act[la].umz-360;
    if act[la].umz<0 then act[la].umz:=act[la].umz+360;
    //Geschwindigkeit begrenzen des Actors
    if act[la].sp>2 then act[la].sp:=2; //Speed Sumand pro Frame
    if act[la].sp<-1 then act[la].sp:=-1;
    //KM/H ausrechnen
    Act[la].kmh := act[la].sp * lastfps * 3.6;
    if Act[la].kmh>320 then act[ac].sp:=act[ac].sp-sync(0.5); //Limit 
    //erst jetzt neue Positionen errechnen
    ux:=act[la].umx; //Rotation um X
    uy:=act[la].umy; //Rotation um Y
    uz:=act[la].umz; //Rotation um Z
    //Die neue Position des Actors ergibt sich aus dem Radius (der gleich der Geschwindigkeit ist) gedreht um den Winkel um die Z Achse
    //Da wo diese gedachte Linie von der Mitte des Actors aus betrachtet aufhrt, ist die neue Koordinate des Actors
    alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt
    y:=act[la].sp; 	//Radius der Rotation = Speed des Actors
    x:=0;  z:=0;		//Spielen in der 2D Darstellung hier keine Rolle
    Rotation(alpha,beta,gamma);
    act[la].x:=act[la].x+x;  act[la].y:=act[la].y+y;  act[la].z:=act[la].z+z; 	//Position um neue Werte erweitern
    act[la].qx:=act[la].qx+x;  act[la].qy:=act[la].qy+y;  act[la].qz:=act[la].qz+z; 	//Position um neue Werte erweitern
    //Wird der Quadrant verlassen?
    if act[la].qx>QXSize then
    begin
      act[la].qx:=act[la].qx-QXSize;
      inc(act[la].wx);
      if act[la].wx=10 then
      begin
        act[la].wx:=0;
        act[la].x:=act[la].x-WXSize*QXSize;
      end;
      act[la].quadrant:=act[la].wy*10+act[la].wx;  //eventuell neuer Quadrant
    end;
    if act[la].qx<0 then
    begin
      act[la].qx:=act[la].qx+QXSize;
      dec(act[la].wx);
      if act[la].wx=-1 then
      begin
        act[la].wx:=9;
        act[la].x:=act[la].x+WXSize*QXSize;
      end;
      act[la].quadrant:=act[la].wy*10+act[la].wx;  //Start im Quadranten 51
    end;
    if act[la].qy>QYSize then
    begin
      act[la].qy:=act[la].qy-QYSize;
      inc(act[la].wy);
      if act[la].wy=10 then
      begin
        act[la].wy:=0;
        act[la].y:=act[la].y-WYSize*QYSize;
      end;
      act[la].quadrant:=act[la].wy*10+act[la].wx;  //Start im Quadranten 51
    end;
    if act[la].qy<0 then
    begin
      act[la].qy:=act[la].qy+QYSize;
      dec(act[la].wy);
      if act[la].wy=-1 then
      begin
        act[la].wy:=9;
        act[la].y:=act[la].y+WYSize*QYSize;
      end;
      act[la].quadrant:=act[la].wy*10+act[la].wx;  //Start im Quadranten 51
    end;
  end;
end;

//-----------------------------------------------------------------------------
// Kollisionen zwischen Actoren und statischen Objekten prfen
//-----------------------------------------------------------------------------
procedure Kollision;
var
  la,lls,lla:integer;
  ax1,ay1,ax2,ay2,sx1,sy1,sx2,sy2:single;
  Quadrant:integer;
begin
  for la:=0 to Actors-1 do //alle Actoren durchgehen
  begin
    Quadrant:=act[la].quadrant;
    if aLin[la].LineCou>0 then
      for lla:=1 to aLin[la].LineCou do
      begin
        //Actor Linie besorgen, die verglichen werden soll
        ax1:=aLin[la].Lines[lla].x1;
        ay1:=aLin[la].Lines[lla].y1;
        ax2:=aLin[la].Lines[lla].x2;
        ay2:=aLin[la].Lines[lla].y2;

        if sLin[Quadrant].LineCou>0 then //gibts es zu vergleichende Linien im Quadranten?
          for lls:=1 to sLin[Quadrant].LineCou do  //dann alle vergleichen
          begin
            //statische Linien besorgen
            sx1:=sLin[Quadrant].Lines[lls].x1;
            sy1:=sLin[Quadrant].Lines[lls].y1;
            sx2:=sLin[Quadrant].Lines[lls].x2;
            sy2:=sLin[Quadrant].Lines[lls].y2;
            if collision(ax1,ay1,ax2,ay2,sx1,sy1,sx2,sy2) then //Kollision zwischen beiden Linien?
            begin
               //Letzte Position wiederherstellen...
              act[la].x:=act[la].lx;
              act[la].y:=act[la].ly;
              act[la].z:=act[la].lz;
              act[la].umx:=act[la].lumx;
              act[la].umy:=act[la].lumy;
              act[la].umz:=act[la].lumz;
              //und Speed zurcksetzen
              act[la].sp:=0;
             end;
          end;
      end;
  end;
end;

//-----------------------------------------------------------------------------
//Fensterfunktion - wird nur aufgerufen wenn Message vorhanden ist - z.B. Mausklick, Mausbewegung, ...
//The WindowProc function is an application-defined callback function that processes messages sent to a window.
//-----------------------------------------------------------------------------
function WindowProc(Window: HWND; AMessage,WParam,LParam: LongInt): LongInt; stdcall; export;
begin
  WindowProc:=0;
  case AMessage of        		//Nachrichten auswerten
    wm_keydown:
      begin
        taste[wparam]:=true;
        lastkey:=wparam;
      end;
    wm_keyup:
      begin
        taste[wparam]:=false;
      end;
    wm_LButtonDown:             	//linke Maustaste gedrueckt?
      begin
      //Beep(100,800);
      end;
    wm_Destroy:                 	//X-oben rechts geklickt zum schliessen der api?
      begin
        PostQuitMessage(0);
        exit;
      end;
  end;
//Standardverarbeitung fr alle anderen Botschaften (Fenster verschieben Grosse verndern...)
//The DefWindowProc function calls the default window procedure to provide default processing for any window messages that an application does not process. This function ensures that every message is processed. DefWindowProc is called with the same parameters received by the window procedure.
  WindowProc:=DefWindowProc(Window,AMessage,WParam,LParam);
end;

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//Programmablauf und Schleife - hier beginnt das ablaufende Programm
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

begin
//Variablen setzen
  setzevars;

//Fensterklasse registrieren
  WindowClass.style:=cs_hRedraw or cs_vRedraw;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.cbCLsExtra:=0;
  WindowClass.cbWNDExtra:=0;
  WindowClass.hInstance:=HInstance;
  WindowClass.hIcon:=loadIcon(0,idi_Application);
  WindowClass.hCursor:=loadcursor(0,idc_Arrow);
  WindowClass.hbrBackground:=HBrush(Color_window);
  WindowClass.lpszMenuName:=nil;
  WindowClass.lpszClassName:=AppName;

  if RegisterClass(WindowClass)=0 then exit; //Wenn Registrierung i.o. dann weiter sonst ende

//Fenster erzeugen
  hWindow:=createWindow(Appname,'schematic drive Part II by R.v.d.Heuvel - Control: ESC,Arrowkeys',ws_Overlappedwindow,
           cw_UseDefault, cw_UseDefault,winwidth,winheight,
           0,0,Hinstance,nil);

//Fenster anzeigen
  if hWindow<>09 then
    begin
    ShowWindow(hWindow,CmdShow); //The ShowWindow function sets the specified window's show state.
    UpdateWindow(hWindow); //The UpdateWindow function updates the client area of the specified window by sending a WM_PAINT message to the window if the window's update region is not empty. The function sends a WM_PAINT message directly to the window procedure of the specified window, bypassing the application queue. If the update region is empty, no message is sent.
    end
  else
    exit;

//Fensterkontext fr Graphicausgabe holen
  canvas:=TCanvas.Create;
  dc:=GetWindowDC(HWindow); //Gertekontext des Fensters holen
  canvas.Handle:=dc; //Zeichenobjekt zugewiesen

//zeichen Hintergrundbitmap machen
  bg:=TBitmap.Create;
  bg.height:=winheight;
  bg.width:=winwidth;

//Message Loop - Hauptschleife
  while running do
  begin
    sysmes:=PeekMessage(AMessage,0,0,0,PM_Remove); //aktuelle Botschaften vom System abfangen ohne den Prosses anzuhalten
    if sysmes then //wenn Message, dann hier weiter machen
    begin
      if Amessage.message=WM_QUIT then
        begin
          running:=false; //Programm soll beendet werden
        end
        else //ansonsten normale Windows Messages weiter verarbeiten
        begin
          TranslateMessage(AMessage); //The TranslateMessage function translates virtual-key messages into character messages. The character messages are posted to the calling thread's message queue, to be read the next time the thread calls the GetMessage or PeekMessage function.
          DispatchMessage(AMessage); //The DispatchMessage function dispatches a message to a window procedure. It is typically used to dispatch a message retrieved by the GetMessage function.
        end;
    end;
      sleep(3);			                  //fr bessere Integration der Anwendung im System SLEEP A LITTLE WHILE
      bg.canvas.fillrect(MyRect); 		//Screen leeren
      BewegungActor; 		              //neue Position der Welt um den Actor ausrechnen
      BewegungCamera;
      calcStaticLines;	              //Hindernisse zeichnen
      calcActorLines;		              //Actor zeichnen
      Kollision;                      //Vergleiche aufgezeichnete Linien auf Kollision
      draw3dGFX;
      screentext;  			              //Info auf Screen
      canvas.copyrect(myrect,bg.canvas,myrect); //Swap gfx - das im Hintergrund gezeichnete sichtbar machen
      zeitmessung; 			              //Frames per Second ermitteln
      tastatur; 				              //Tastaturabfrage wird kontinuierlich aufgerufen
      AnsichtAutomatischWechseln;     //Was wohl?
  end;

//Programmende
  bg.free; 					//Zeichenbitmap freigeben
  releaseDC(0,dc); 				//Gertekontext fr Grafikausgabe auflsen
  Halt(AMessage.wParam);  			//Die Prozedur Halt lst einen Programmabbruch aus und gibt die Steuerung an das Betriebssystem zurck
end. 						//Endmarke




